searchNodes=[{"doc":"Struct to contain the protocol messages.See https://github.com/apollographql/subscriptions-transport-ws/blob/master/PROTOCOL.md for more details on their contents","ref":"SubscriptionsTransportWS.OperationMessage.html","title":"SubscriptionsTransportWS.OperationMessage","type":"module"},{"doc":"Prepare message for transport, removing any keys with nil values.iex&gt; %OperationMessage{type: &quot;complete&quot;, id: &quot;1&quot;} |&gt; OperationMessage.as_json %{id: &quot;1&quot;, type: &quot;complete&quot;}","ref":"SubscriptionsTransportWS.OperationMessage.html#as_json/1","title":"SubscriptionsTransportWS.OperationMessage.as_json/1","type":"function"},{"doc":"Build OperationMessage from incoming mapiex&gt; %{&quot;type&quot; =&gt; &quot;connection_init&quot;} |&gt; OperationMessage.from_map %OperationMessage{id: nil, type: &quot;connection_init&quot;, payload: nil}","ref":"SubscriptionsTransportWS.OperationMessage.html#from_map/1","title":"SubscriptionsTransportWS.OperationMessage.from_map/1","type":"function"},{"doc":"","ref":"SubscriptionsTransportWS.OperationMessage.html#t:t/0","title":"SubscriptionsTransportWS.OperationMessage.t/0","type":"type"},{"doc":"Implementation of the subscriptions-transport-ws graphql subscription protocol for Absinthe. Instead of using Absinthe subscriptions over Phoenix channels it exposes a websocket directly. This allows you to use the Apollo and Urql Graphql clients without using a translation layer to Phoenix channels such as @absinthe/socket. Has been tested with Apollo iOS and Urql with subscriptions-transport-ws.InstallationIf available in Hex, the package can be installed by adding subscriptions_transport_ws to your list of dependencies in mix.exs:def deps do [ {:subscriptions_transport_ws, &quot;~&gt; 1.0.0&quot;} ] endUsageThere are several steps to use this library. You need to have a working phoenix pubsub configured. Here is what the default looks like if you create a new phoenix project:config :my_app, MyAppWeb.Endpoint, # ... other config pubsub_server: MyApp.PubSubIn your application supervisor add a line AFTER your existing endpoint supervision line:[ # other children ... MyAppWeb.Endpoint, # this line should already exist {Absinthe.Subscription, MyAppWeb.Endpoint}, # add this line # other children ... ]Where MyAppWeb.Endpoint is the name of your application's phoenix endpoint.Add a module in your app lib/web/channels/absinthe_socket.exdefmodule AbsintheSocket do # App.GraphqlSchema is your graphql schema use SubscriptionsTransportWS.Socket, schema: App.GraphqlSchema, keep_alive: 1000 # Callback similar to default Phoenix UserSocket @impl true def connect(params, socket) do {:ok, socket} end # Callback to authenticate the user @impl true def gql_connection_init(message, socket) do {:ok, socket} end endIn your MyAppWeb.Endpoint module add: defmodule MyAppWeb.Endpoint do use Phoenix.Endpoint, otp_app: :my_app use Absinthe.Phoenix.Endpoint socket(&quot;/absinthe-ws&quot;, AbsintheSocket, websocket: [subprotocols: [&quot;graphql-ws&quot;]]) # ... endNow if you start your app you can connect to the socket on ws://localhost:4000/absinthe-ws/websocketExample with Urqlimport { SubscriptionClient } from &quot;subscriptions-transport-ws&quot;; import { useSubscription, Provider, defaultExchanges, subscriptionExchange, } from &quot;urql&quot;; const subscriptionClient = new SubscriptionClient( &quot;ws://localhost:4000/absinthe-ws/websocket&quot;, { reconnect: true, } ); const client = new Client({ url: &quot;http://localhost:4000/api&quot;, exchanges: [ subscriptionExchange({ forwardSubscription(operation) { return subscriptionClient.request(operation); }, }), ...defaultExchanges, ], });See the Urql documentation for more information.Example with SwiftSee here https://www.apollographql.com/docs/ios/subscriptions/#subscriptions-and-authorization-tokens","ref":"SubscriptionsTransportWS.Socket.html","title":"SubscriptionsTransportWS.Socket","type":"behaviour"},{"doc":"","ref":"SubscriptionsTransportWS.Socket.html#assign/2","title":"SubscriptionsTransportWS.Socket.assign/2","type":"function"},{"doc":"Adds key value pairs to socket assigns. A single key value pair may be passed, a keyword list or map of assigns may be provided to be merged into existing socket assigns.Examplesiex&gt; assign(socket, :name, &quot;Elixir&quot;) iex&gt; assign(socket, name: &quot;Elixir&quot;, logo: &quot;💧&quot;)","ref":"SubscriptionsTransportWS.Socket.html#assign/3","title":"SubscriptionsTransportWS.Socket.assign/3","type":"function"},{"doc":"Adds key-value pairs into Absinthe context.Examplesiex&gt; Socket.assign_context(socket, current_user: user) %Socket{}","ref":"SubscriptionsTransportWS.Socket.html#assign_context/2","title":"SubscriptionsTransportWS.Socket.assign_context/2","type":"function"},{"doc":"Same as assign_context/2 except one key-value pair is assigned.","ref":"SubscriptionsTransportWS.Socket.html#assign_context/3","title":"SubscriptionsTransportWS.Socket.assign_context/3","type":"function"},{"doc":"Receives the socket params and authenticates the connection.Socket params and assignsSocket params are passed from the client and can be used to verify and authenticate a user. After verification, you can put default assigns into the socket that will be set for all channels, ie{:ok, assign(socket, :user_id, verified_user_id)}To deny connection, return :error.See Phoenix.Token documentation for examples in performing token verification on connect.","ref":"SubscriptionsTransportWS.Socket.html#c:connect/2","title":"SubscriptionsTransportWS.Socket.connect/2","type":"callback"},{"doc":"","ref":"SubscriptionsTransportWS.Socket.html#c:connect/3","title":"SubscriptionsTransportWS.Socket.connect/3","type":"callback"},{"doc":"Default pipeline to use for Absinthe graphql document execution","ref":"SubscriptionsTransportWS.Socket.html#default_pipeline/2","title":"SubscriptionsTransportWS.Socket.default_pipeline/2","type":"function"},{"doc":"Callback for the connection_init message. The client sends this message after plain websocket connection to start the communication with the server.In the subscriptions-transport-ws protocol this is usually used to set the user on the socket.Should return {:ok, socket} on success, and {:error, payload} to deny.Receives the a map of connection_params, seeconnectionParams in Apollo javascript clientconnectingPayload in Apollo iOS clientor similar in other clients.","ref":"SubscriptionsTransportWS.Socket.html#c:gql_connection_init/2","title":"SubscriptionsTransportWS.Socket.gql_connection_init/2","type":"callback"},{"doc":"Sets the options for a given GraphQL document execution.Examplesiex&gt; SubscriptionsTransportWS.Socket.put_options(socket, context: %{current_user: user}) %SubscriptionsTransportWS.Socket{}","ref":"SubscriptionsTransportWS.Socket.html#put_options/2","title":"SubscriptionsTransportWS.Socket.put_options/2","type":"function"},{"doc":"When using this module there are several options availablejson_module - defaults to Jasonschema - refers to the Absinthe schema (required)pipeline - refers to the Absinthe pipeline to use, defaults to {SubscriptionsTransportWS.Socket, :default_pipeline}keep_alive period in ms to send keep alive messages over the socket, defaults to 10000Exampleuse SubscriptionsTransportWS.Socket, schema: App.GraphqlSchema, keep_alive: 1000","ref":"SubscriptionsTransportWS.Socket.html#t:t/0","title":"SubscriptionsTransportWS.Socket.t/0","type":"type"},{"doc":"Helper module for testing socket behaviours.Usage# Example socket defmodule GraphqlSocket do use SubscriptionsTransportWS.Socket, schema: TestSchema, keep_alive: 10 @impl true def connect(params, socket) do {:ok, socket} end @impl true def gql_connection_init(message, socket) do {:ok, socket} end end # Endpoint routes to the socket defmodule YourApp.Endpoint do use Phoenix.Endpoint, otp_app: :subscription_transport_ws use Absinthe.Phoenix.Endpoint socket(&quot;/ws&quot;, GraphqlSocket, websocket: [subprotocols: [&quot;graphql-ws&quot;]]) # ... rest of your endpoint end # Test suite defmodule SomeTest do use ExUnit.Case import SubscriptionsTransportWS.SocketTest @endpoint YourApp.Endpoint test &quot;a test&quot; do socket(GraphqlSocket, TestSchema) # Push query over socket and receive response assert {:ok, %{&quot;data&quot; =&gt; %{&quot;posts&quot; =&gt; [%{&quot;body&quot; =&gt; &quot;body1&quot;, &quot;id&quot; =&gt; &quot;aa&quot;}]}}, _socket} = push_doc(socket, &quot;query { posts { id body } }&quot;, variables: %{limit: 10}) # Subscribe to subscription {:ok, socket} = push_doc(socket, &quot;subscription { postAdded{ id body title } }&quot;, variables: %{}) end end","ref":"SubscriptionsTransportWS.SocketTest.html","title":"SubscriptionsTransportWS.SocketTest","type":"module"},{"doc":"Helper function to receive subscription data over the socketExamplepush_doc(socket, &quot;mutation submitPost($title: String, $body: String){ submitPost(title: $title, body: $body){ id body title } }&quot;, variables: %{title: &quot;test title&quot;, body: &quot;test body&quot;}) assert_receive_subscription %{ &quot;data&quot; =&gt; %{ &quot;postAdded&quot; =&gt; %{&quot;body&quot; =&gt; &quot;test body&quot;, &quot;id&quot; =&gt; &quot;1&quot;, &quot;title&quot; =&gt; &quot;test title&quot;} } }","ref":"SubscriptionsTransportWS.SocketTest.html#assert_receive_subscription/2","title":"SubscriptionsTransportWS.SocketTest.assert_receive_subscription/2","type":"macro"},{"doc":"Initiates a transport connection for the socket handler. Useful for testing UserSocket authentication. Returns the result of the handler's connect/3 callback.","ref":"SubscriptionsTransportWS.SocketTest.html#connect/3","title":"SubscriptionsTransportWS.SocketTest.connect/3","type":"macro"},{"doc":"Helper function for the connection_init message in the subscriptions-transport-ws protocol. Calls the gql_connection_init(message, socket) on the socket handler.","ref":"SubscriptionsTransportWS.SocketTest.html#gql_connection_init/2","title":"SubscriptionsTransportWS.SocketTest.gql_connection_init/2","type":"function"},{"doc":"Helper function to push a GraphQL document to a socket.The only option that is used is opts[:variables] - all other options are ignored.When you push a query/mutation it will return with {:ok, result, socket}. For subscriptions it will return an {:ok, socket} tuple.Example of synchronous response# Push query over socket and receive response push_doc(socket, &quot;query { posts { id body } }&quot;, variables: %{limit: 10}) {:ok, %{&quot;data&quot; =&gt; %{&quot;posts&quot; =&gt; [%{&quot;body&quot; =&gt; &quot;body1&quot;, &quot;id&quot; =&gt; &quot;aa&quot;}]}}, _socket}Example of asynchronous response# Subscribe to subscription push_doc(socket, &quot;subscription { postAdded{ id body title } }&quot;, variables: %{}) # The submitPost mutation triggers the postAdded subscription publication push_doc(socket, &quot;mutation submitPost($title: String, $body: String){ submitPost(title: $title, body: $body){ id body title } }&quot;, variables: %{title: &quot;test title&quot;, body: &quot;test body&quot;}) assert_receive_subscription(%{ &quot;data&quot; =&gt; %{ &quot;postAdded&quot; =&gt; %{&quot;body&quot; =&gt; &quot;test body&quot;, &quot;id&quot; =&gt; &quot;1&quot;, &quot;title&quot; =&gt; &quot;test title&quot;} } })","ref":"SubscriptionsTransportWS.SocketTest.html#push_doc/3","title":"SubscriptionsTransportWS.SocketTest.push_doc/3","type":"function"},{"doc":"Helper function to build a socket.Example iex&gt; socket = socket(GraphqlSocket, TestSchema)","ref":"SubscriptionsTransportWS.SocketTest.html#socket/2","title":"SubscriptionsTransportWS.SocketTest.socket/2","type":"macro"},{"doc":"","ref":"SubscriptionsTransportWS.Error.html","title":"SubscriptionsTransportWS.Error","type":"exception"}]